'use strict';

exports.__esModule = true;

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = createConnect;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _utilsCreateStoreShape = require('../utils/createStoreShape');

var _utilsCreateStoreShape2 = _interopRequireDefault(_utilsCreateStoreShape);

var _utilsShallowEqualScalar = require('../utils/shallowEqualScalar');

var _utilsShallowEqualScalar2 = _interopRequireDefault(_utilsShallowEqualScalar);

var _utilsShallowEqual = require('../utils/shallowEqual');

var _utilsShallowEqual2 = _interopRequireDefault(_utilsShallowEqual);

var _utilsIsPlainObject = require('../utils/isPlainObject');

var _utilsIsPlainObject2 = _interopRequireDefault(_utilsIsPlainObject);

var _utilsWrapActionCreators = require('../utils/wrapActionCreators');

var _utilsWrapActionCreators2 = _interopRequireDefault(_utilsWrapActionCreators);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var defaultMapState = function defaultMapState() {
  return {};
};
var defaultMapDispatch = function defaultMapDispatch(dispatch) {
  return { dispatch: dispatch };
};
var defaultMergeProps = function defaultMergeProps(stateSlice, actionsCreators, props) {
  return _extends({}, props, stateSlice, actionsCreators);
};

function getDisplayName(Component) {
  return Component.displayName || Component.name || 'Component';
}

function createConnect(React) {
  var Component = React.Component;
  var PropTypes = React.PropTypes;

  var storeShape = _utilsCreateStoreShape2['default'](PropTypes);

  return function connect() {
    var _mapState = arguments.length <= 0 || arguments[0] === undefined ? defaultMapState : arguments[0];

    var mapDispatchOrActionCreators = arguments.length <= 1 || arguments[1] === undefined ? defaultMapDispatch : arguments[1];
    var mergeProps = arguments.length <= 2 || arguments[2] === undefined ? defaultMergeProps : arguments[2];

    var shouldSubscribe = _mapState !== defaultMapState;
    var _mapDispatch = _utilsIsPlainObject2['default'](mapDispatchOrActionCreators) ? _utilsWrapActionCreators2['default'](mapDispatchOrActionCreators) : mapDispatchOrActionCreators;

    return function (DecoratedComponent) {
      return (function (_Component) {
        _inherits(ConnectDecorator, _Component);

        ConnectDecorator.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
          return this.subscribed && !this.isSliceEqual(this.state.slice, nextState.slice) || !_utilsShallowEqualScalar2['default'](this.props, nextProps);
        };

        ConnectDecorator.prototype.isSliceEqual = function isSliceEqual(slice, nextSlice) {
          var isRefEqual = slice === nextSlice;
          if (isRefEqual || typeof slice !== 'object' || typeof nextSlice !== 'object') {
            return isRefEqual;
          }

          return _utilsShallowEqual2['default'](slice, nextSlice);
        };

        _createClass(ConnectDecorator, null, [{
          key: 'displayName',
          value: 'Connect(' + getDisplayName(DecoratedComponent) + ')',
          enumerable: true
        }, {
          key: 'DecoratedComponent',
          value: DecoratedComponent,
          enumerable: true
        }, {
          key: 'contextTypes',
          value: {
            store: storeShape.isRequired
          },
          enumerable: true
        }]);

        function ConnectDecorator(props, context) {
          _classCallCheck(this, ConnectDecorator);

          _Component.call(this, props, context);
          this.setUnderlyingRef = this.setUnderlyingRef.bind(this);
          this.state = _extends({}, this.mapState(props, context), this.mapDispatch(context));
        }

        ConnectDecorator.prototype.componentDidMount = function componentDidMount() {
          if (shouldSubscribe) {
            this.subscribed = true;
            this.unsubscribe = this.context.store.subscribe(this.handleChange.bind(this));
          }
        };

        ConnectDecorator.prototype.componentWillUnmount = function componentWillUnmount() {
          if (shouldSubscribe) {
            this.unsubscribe();
          }
        };

        ConnectDecorator.prototype.handleChange = function handleChange() {
          var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];

          var nextState = this.mapState(props, this.context);
          if (!this.isSliceEqual(this.state.slice, nextState.slice)) {
            this.setState(nextState);
          }
        };

        ConnectDecorator.prototype.mapState = function mapState() {
          var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];
          var context = arguments.length <= 1 || arguments[1] === undefined ? this.context : arguments[1];

          var state = context.store.getState();
          var slice = _mapState(state);

          _invariant2['default'](_utilsIsPlainObject2['default'](slice), '`mapState` must return an object. Instead received %s.', slice);

          return { slice: slice };
        };

        ConnectDecorator.prototype.mapDispatch = function mapDispatch() {
          var context = arguments.length <= 0 || arguments[0] === undefined ? this.context : arguments[0];
          var dispatch = context.store.dispatch;

          var actionCreators = _mapDispatch(dispatch);

          _invariant2['default'](_utilsIsPlainObject2['default'](actionCreators), '`mapDispatch` must return an object. Instead received %s.', actionCreators);

          return { actionCreators: actionCreators };
        };

        ConnectDecorator.prototype.merge = function merge() {
          var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];
          var state = arguments.length <= 1 || arguments[1] === undefined ? this.state : arguments[1];
          var slice = state.slice;
          var actionCreators = state.actionCreators;

          var merged = mergeProps(slice, actionCreators, props);

          _invariant2['default'](_utilsIsPlainObject2['default'](merged), '`mergeProps` must return an object. Instead received %s.', merged);

          return merged;
        };

        ConnectDecorator.prototype.getUnderlyingRef = function getUnderlyingRef() {
          return this.underlyingRef;
        };

        ConnectDecorator.prototype.setUnderlyingRef = function setUnderlyingRef(instance) {
          this.underlyingRef = instance;
        };

        ConnectDecorator.prototype.render = function render() {
          return React.createElement(DecoratedComponent, _extends({ ref: this.setUnderlyingRef
          }, this.merge()));
        };

        return ConnectDecorator;
      })(Component);
    };
  };
}

module.exports = exports['default'];